threeJs();

function threeJs(){

	if ( ! Detector.webgl ) 
		Detector.addGetWebGLMessage();

	var container, stats, controls;
	var camera, scene, renderer, light;
	var mixer = null;
	var clock = new THREE.Clock();

	var mesh, skeleton;

	var background3D;
	var backgroundCamera, backgroundScene;

	var envmap;

	init();
	animate();

	function init() {

		container = document.createElement( 'div' );
		document.body.appendChild( container );
			
		scene = new THREE.Scene();

		creatingCameras();
		function creatingCameras(){
			//Perspective
			camera = new THREE.PerspectiveCamera( 45, window.innerWidth / window.innerHeight, 0.25, 400 );
			camera.position.set( 0, 0, 10 );
			//Orthographics for HUD
			//camera = new THREE.OrthographicCamera(window.innerWidth / - 2, window.innerWidth / 2, window.innerHeight / 2, window.innerHeight / - 2, 1, 1000000);
			//camera.position.set(0,0,0);

		}
		controls = new THREE.OrbitControls( camera );
		controls.target.set( 0, 0, 0 );
		controls.update();


		creatingLights();	//Light
		function creatingLights(){
			//Light
			light = new THREE.HemisphereLight( 0xbbbbff, 0x444422 );
			light.position.set( 0, 1, 0 );
			scene.add( light );

			light = new THREE.DirectionalLight( 0xffffff );
			light.position.set( -5,100, 1000);
			scene.add( light );
		}
		
		creatingModels();
		function creatingModels(){	

			var loader = new THREE.GLTFLoader();
			loader.load('sources/models/v01/Kbot_construct3.gltf', function ( gltf ) {

				var object = gltf.scene;

				object.traverse(function (child) {

					if (child.isMesh) {

						if(child.material.name == "K_light"){
							//child.material.envMap = envMap;	
							child.material.transparent = true;
							child.material.blending = THREE.AdditiveBlending;					
						}
						
					}

					child.castShadow = false;
					child.receiveShadow = false;
				});

				skeleton = new THREE.SkeletonHelper(object);
				skeleton.visible = true;
				scene.add(skeleton);

				mixer = new THREE.AnimationMixer( object );
				
				var animations = gltf.animations;

				splitAnimations();
				function splitAnimations(){
					//Split Animations
					var idleClip = THREE.AnimationUtils.subclip(animations[0],'idle', 30,40);
					//var helloClip = THREE.AnimationUtils.subclip(animations[0], 'hello',10, 20);

					var idleAction = mixer.clipAction(idleClip);
					//var helloAction = mixer.clipAction(helloClip);
					//console.log(helloAction);
					setWeight(idleAction, 1);
					
				}
				
				//mixerAnimations();
				function mixerAnimations(){
					if ( animations && animations.length ) {
						for ( var i = 0; i < animations.length; i ++ ) {
							mixer.clipAction( animations[i] ).play();
						}
					}
				}


				//Set attributes, positions, etc.
				object.position.set(-8,-1.5,-10);
				object.lookAt(camera.position.x, camera.position.y - 5, camera.position.z);

				scene.add(object);
			} );
		}


		function executeCrossFade(startAction, endAction, duration){

		}
		function setWeight(action, weight){

			action.enabled = true;
			action.setEffectiveTimeScale(1);
			action.setEffectiveWeight(weight);

			action.play();
		}
		//Renderer Configs
		renderer = new THREE.WebGLRenderer( { antialias: true } );
		renderer.setPixelRatio( window.devicePixelRatio );
		renderer.setSize( window.innerWidth, window.innerHeight );
		renderer.gammaOutput = true;
		container.appendChild( renderer.domElement );

		window.addEventListener( 'resize', onWindowResize, false );
		//Stats
		stats = new Stats();
		//container.appendChild( stats.dom );
	}
	function onWindowResize() {
		camera.aspect = window.innerWidth / window.innerHeight;
		camera.updateProjectionMatrix();
		renderer.setSize( window.innerWidth, window.innerHeight );
	}
	//
	function animate() {
		requestAnimationFrame( animate );
		
		if (mixer) 
			mixer.update(clock.getDelta());
		
		controls.update();
		stats.update();

		render();
	}

	function render() {
		renderer.render( scene, camera );
	}
}	